#define time_btn 500                        //  -  
#define beep_time 250                       //  
#define LED_time 1                          //   
#define tick_number 7813                    //    ,     ,   ,  7812.5  
#define g PORTA.F0                          //  g
#define c PORTA.F1                          //  c
#define d PORTA.F2                          //  d
#define e PORTA.F3                          //  e
#define a PORTA.F4                          //  a
#define b PORTA.F6                          //  b
#define f PORTA.F7                          //  f
#define OUT PORTB.F2                        //  
#define P100 PORTB.F1                       //  
#define P010 PORTB.F6                       //  
#define P001 PORTB.F7                       //  
#define BUZZER PORTB.F3                     //  
#define BTN PORTB.F0                        //   
#define ENC_PORT PORTB                      //   
#define ENC_A_PIN F4                        //  
#define ENC_B_PIN F5                        //      
#define ENC_BITS 0b00110000                 //  ,  : F5  F4  , 5  4   1
//                 76543210                 //    -    
#define SHIFT_R 4                           //      ,  ,    
////////////////////////////////////////////// RA5 -   !!!     !!! ////////////////////////////////////
////////////////////////////////////////////// RB0  RB3 -  CCP  /////////////////////////////////////////////////////

//--------------------------------------------  ----------------------------------------------------------------------------
bit beep_on;
char button, place, preset, state, enc_state_new, enc_state_old;
short corr, digit, encoder, var;
int time, time_set, timer_tick;
//--------------------------------------------   ----------------------------------------------------------------------

// +++++++++++++++++++++++++++++++++++++++++++  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--------------------------------------------   ------------------------------------------------------------------------
void beep(void)
 {
  if(beep_on)                               //       
   {
    PORTA = 0;                              //   
    BUZZER = 1;                             //    1,    
    delay_ms(beep_time);                    //       
    BUZZER = 0;                             //   0
    delay_ms(beep_time);                    //   ,       
   }
 }//------------------------------------------   -------------------------------------------------------------------------
 
//--------------------------------------------     ----------------------------------------------------------
void display(void)
 {
  PORTA = 0;                                //   
  switch (place)                            //   0 -  
   {
    case 0: P001 = 1; P010 = 0; P100 = 0; break;
    case 1: P001 = 0; P010 = 1; P100 = 0; break;
    case 2: P001 = 0; P010 = 0; P100 = 1;
   }
  switch (digit)                            //      
   {
    case 0: a=b=c=d=e=f=1; break;
    case 1: b=c=1; break;
    case 2: a=b=g=e=d=1; break;
    case 3: a=b=g=c=d=1; break;
    case 4: f=b=g=c=1; break;
    case 5: a=f=g=c=d=1; break;
    case 6: a=f=g=e=c=d=1; break;
    case 7: a=b=c=1; break;
    case 8: a=b=c=d=e=f=g=1; break;
    case 9: a=b=c=d=f=g=1; break;
    case 10:a=b=c=e=f=1; break;             //  n
    case 11:a=e=f=g=1; break;               //  F
    case 12:a=b=e=f=g=1; break;             //  P
    case 13:e=g=1; break;                   //  r
    case 14:g=1; break;                     // - 
    case 15:a=c=d=f=g=1; break;             //  S
    case 16:b=c=d=e=g=1; break;             //  d
    case 17:b=c=d=g=1; break;               //  t
    case 18:a=d=e=f=1; break;               //  C
    case 19:a=d=e=f=g=1;                    //  E,       -   
   }
  delay_ms(LED_time);                       //    ,   
 }
//--------------------------------------------      ----------------------------------------------------

//--------------------------------------------     -------------------------------------------------------------
void time_read(void)
 {                                          
  switch(preset)                            //          
   {
    case 1: time_set = EEPROM_read(0x11); break;
    case 2: time_set = EEPROM_read(0x12); break;
    case 3: time_set = EEPROM_read(0x13); break;
    case 4: time_set = EEPROM_read(0x14); break;
    case 5: time_set = EEPROM_read(0x15); break;
    case 6: time_set = EEPROM_read(0x16); break;
    case 7: time_set = EEPROM_read(0x17); break;
    case 8: time_set = EEPROM_read(0x18); break;
    case 9: time_set = EEPROM_read(0x19);   //       -   
   }
  time = time_set*5;                        //      
 } 
//--------------------------------------------      -------------------------------------------------------

//--------------------------------------------     ---------------------------------------------------------------
void time_write(void)
 { 
  time_set = time / 5;                      //      
  switch(preset)                            //          
   {
    case 1: EEPROM_write(0x11, time_set); break;
    case 2: EEPROM_write(0x12, time_set); break;
    case 3: EEPROM_write(0x13, time_set); break;
    case 4: EEPROM_write(0x14, time_set); break;
    case 5: EEPROM_write(0x15, time_set); break;
    case 6: EEPROM_write(0x16, time_set); break;
    case 7: EEPROM_write(0x17, time_set); break;
    case 8: EEPROM_write(0x18, time_set); break;
    case 9: EEPROM_write(0x19, time_set);       //       -   
   }
 } 
//--------------------------------------------      ---------------------------------------------------------

//--------------------------------------------    RB0 ----------------------------------------------------------
void clear(void)
 {
  button = 0;                               //   
  INTF_bit = 0;                             //     RB0
  INT0IE_bit = 1;                           //    RB0
}
//--------------------------------------------     RB0 ----------------------------------------------------

//--------------------------------------------     -------------------------------------------------
void saved(void)
 {
  TMR0IE_bit = 1;                           //     
  timer_tick = 0;                           //    
  while(timer_tick < tick_number/2)         //        
   {
    if(beep_on == 1) BUZZER = 1;            //    - 
    digit = 14;                             //     
    place = 0;
    display(); 
    place = 1;  
    display();
    place = 2;
    display();
   }
  BUZZER = 0;
  timer_tick = 0;                           //     
  TMR0IE_bit = 0;                           //    
 }
//--------------------------------------------      -------------------------------------------
//++++++++++++++++++++++++++++++++++++++++++++   ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//============================================  ============================================================================
void interrupt(void)
 {
  if(INTCON.TMR0IF)//-------------------------    TMR0 -------------------------------------------------------
   {                                        //  
    TMR0IF_bit = 0;                         //     
    timer_tick++;                           //   
    if(timer_tick >= tick_number + corr*5)  //     -   ,       10
     {                                      //     ,     
      timer_tick=0;                         //    - 
      if(state == 3) time--;                //   ,       
     }
   }//----------------------------------------     TMR0 -------------------------------------------------

  if(INTCON.INTF)//---------------------------   RB0 ---------------------------------------------------------------------
   {
    INT0IE_bit = 0;                         //    RB0
    PORTA = 0;                              //   ,         
    delay_ms(time_btn);                     //    
    if (PORTB.F0 == 0) 
     {
      button = 2;                           //       - 
      beep();                               // ,   
     }
     else button = 1;                       //  -  
    INTF_bit = 0;                           //     RB0
    while(PORTB.F0==0) NOP();               // ,   
   }//----------------------------------------    RB0 ---------------------------------------------------------------
   
  if(INTCON.RBIF)//--------------------------    RB1-7 -   ----------------------------------------------
   {
    RBIE_bit = 0;                           //    RB1-7
    if(!ENC_PORT.ENC_A_PIN || !ENC_PORT.ENC_B_PIN)
     {                                      //    
      enc_state_new = ENC_PORT & ENC_BITS;  //     
      enc_state_new = enc_state_new >> SHIFT_R;//      
      switch(enc_state_old)                 //   
       {
        case 0:
         {
          if(enc_state_new == 2) var++;
          if(enc_state_new == 1) var--;
          break;
         }
        case 1:
         {
          if(enc_state_new == 0) var++;
          if(enc_state_new == 3) var--;
          break;
         }
        case 2:
         {
          if(enc_state_new == 3) var++;
          if(enc_state_new == 0) var--;
          break;
         }
        case 3:
         {
          if(enc_state_new == 1) var++;
          if(enc_state_new == 2) var--;
         }
       }//------------------------------------    
      if (var == 2)                         //    2  
       {        
        encoder = -1;                       //    2
        var = 0;                            //   
       }
      if (var == -2)                        //    2  
       {
        encoder = 1;                        //    2
        var = 0;                            //   
       }
      enc_state_old = enc_state_new;        //      
     }//--------------------------------------     
    RBIF_bit = 0;                           //     RB4-7
    RBIE_bit = 1;                           //    RB4-7
   }//----------------------------------------    RB4-7 -------------------------------------------------------------
}//===========================================   ======================================================================

//============================================  ==================================================================================
void main()
 {
  OSCCON = 0b01110000;                      // 8MHz,  
//           |||||||+------------------------- 0 SCS: 1-0  
//           ||||||+-------------------------- 1 00 -  FOSC, 01 - T1OSC, 10 - INTRC, 11 -   
//           |||||+--------------------------- 2 IOFS: : 1 -  , 0 - 
//           ||||+---------------------------- 3 OSTS: : 1 -  , 0 - T1OSC  INTRC   
//           |||+----------------------------- 4 IRCF: 6-4   
//           ||+------------------------------ 5 000 - 31,25   001 - 125    010 - 250    011 - 500 
//           |+------------------------------- 6 100 - 1       101 - 2      110 - 4      111 - 8
//           +-------------------------------- 7 -  ,   0

  OPTION_REG = 0b00001111;                  //    WDT(), TMR0    ,      RB0  
//               |||||||+--------------------- 0 2-0  ,   WDT,    TMR0,     2
//               ||||||+---------------------- 1 000 - 1:1   001 - 1:2   010 - 1:4   011 - 1:8
//               |||||+----------------------- 2 100 - 1:16  101 - 1:32  110 - 1:64  111 - 1:128
//               ||||+------------------------ 3 PSA:    1 - WDT, 0 - TMR0
//               |||+------------------------- 4 T0SE:       TMR0  T1OSC
//               ||+-------------------------- 5 T0CS:     TMR0 1 - T0CKI pin, 0 -  CLKO
//               |+--------------------------- 6 INTEDG:       RB0: 1 - , 0 - 
//               +---------------------------- 7 RBPU:    : 0 , 1 - 

//INTCON = 0b10011000;                       //    
//           |||||||+------------------------- 0 RBIF: RB Port Change Interrupt Flag, 1 - , 0 -  
//           ||||||+-------------------------- 1 INT0IF: RB0/INT External Interrupt Flag
//           |||||+--------------------------- 2 TMR0IF: TMR0 Overflow Interrupt Flag
//           ||||+---------------------------- 3 RBIE: RB Port Change Interrupt Enable, 1 - , 0 - 
//           |||+----------------------------- 4 INT0IE: RB0/INT External Interrupt Enable
//           ||+------------------------------ 5 TMR0IE: TMR0 Overflow Interrupt Enable
//           |+------------------------------- 6 PEIE: Peripheral Interrupt Enable
//           +-------------------------------- 7 GIE: Global Interrupt Enable
                                            //            , :
// OPTION_REG.F7 = 0;                       //     
// OPTION_REG.INTEDG = 1;                   //     RB0

  ANSEL = 0;                                //   
  TRISA = 0;                                //    
  TRISB = 0;                                //  B  
  PORTB = 0;                                //     0,     
  PORTA = 0;                                //    ,     
  TMR0 = timer_tick = button = encoder = 0; //    
  state = 1;                                //   !
  beep_on = EEPROM_read(0x01);              //    
  corr = EEPROM_read(0x02);                 //   
  preset = EEPROM_read(0x00);               //   
  time_read();                              //    
  TRISB = 0b00110001;                       //     
  beep();                                   //    
  if (beep_on == 0) delay_ms(time_btn);     //         
  if (preset == 255)                        //    255 -          
   {                                        
    EEPROM_write(0x00, 1);                  //  
    EEPROM_write(0x01, 1);                  // 
    EEPROM_write(0x02, 0);                  // 
    EEPROM_write(0x11, 20);                 //  
    EEPROM_write(0x12, 40);
    EEPROM_write(0x13, 60);
    EEPROM_write(0x14, 80);
    EEPROM_write(0x15, 100);
    EEPROM_write(0x16, 120);
    EEPROM_write(0x17, 140);
    EEPROM_write(0x18, 160);
    EEPROM_write(0x19, 180);                //  
    beep_on = preset = 1;
    delay_ms(25);                           //  25    .     ,    
    time_read();                            //    
    corr = 0;
   }
   INTCON = 0b10011000;                    //   ,  RB0    RB4-7
   RBIF_bit = 0;                           //     RB4-7
//--------------------------------------------  -----------------------------------------------------------------------------
  if (PORTB.F0 == 0)                        //             
   {
    timer_tick = 0;                         //    
    TMR0IE_bit = 1;                         //     
    while(timer_tick < tick_number - 50)    //        
     {                                      //     Snd
      digit = 16;                           //  d
      place = 0;                            // 
      display();                            // 
      digit = 10;                           //  n
      place = 1;                            // 
      display();                            // 
      digit = 15;                           //  S
      place = 2;                            // 
      display();                            // 
     }
    TMR0IE_bit = 0;                         //    
    clear();                                //    RB0   
    for(;;)//---------------------------------     
     {
      if(encoder) beep_on=1;                //       
      if(encoder==-1) beep_on=0;            //   - 
      encoder = 0;                          //    
      if(!beep_on)                          //     
       {                                    // 
        place = 0;                          //  
        digit = 11;                         //  F
        display();                          // 
        place = 1;                          // 
        display();                          // 
        place = 2;                          // 
        digit = 0;                          // 0   
        display();                          // 
       }
        else                                //  
         {
          place = 0;                        // 
          digit = 10;                       //  n
          display();                        // 
          digit = 0;                        // 0   
          place = 1;                        // 
          display();                        // 
          place = 2;                        // 
          digit = 99;                       //  ,    
          display();                        //  ,        ,     
         }
      if(button == 1 || button == 2)        //    
       {
        EEPROM_write(0x01, beep_on);        // 
        saved();                            // 
        clear();                            //    
        break;                              //       
       }  
     }//--------------------------------------   
    timer_tick = 0;                         //    
    TMR0IE_bit = 1;                         //    
    while(timer_tick < tick_number - 50)    //        
     {                                      //     Snd
      digit = 13;                           //  r
      place = 0;                            // 
      display();                            // 
      digit = 0;                            //  O
      place = 1;                            // 
      display();                            // 
      digit = 18;                           //  C
      place = 2;                            // 
      display();                            // 
     }
    TMR0IE_bit = 0;                         //      
    for(;;)//---------------------------------     
     {
      corr = corr + encoder;                //    
      encoder = 0;                          //    
      if (corr < -99)                       //  ,     
       {
        beep();                             //  
        corr = -99;                         //  
       }
      if (corr > 99)                        //  ,     
       {
        beep();                             //  
        corr = 99;                          //  
       }

      if (corr > -1) digit = 99;            //       ,    ,    
       else digit = 14;                     //     
      place = 2;                            //    
      display();                            // 
      digit = corr/10;                      //   
      if (digit < 0) digit = digit *-1;     //  ,    -1
      place = 1;                            //   
      display();                            //  
      digit = corr%10;                      //  
      if (digit < 0) digit = digit *-1;     //  ,    -1
      place = 0;                            // 
      display();                            // 
      
      if(button == 1 || button == 2)        //    
       {
        EEPROM_write(0x02, corr);           // 
        saved();                            // 
        clear();                            //    
        break;                              //       
       }     
     }//--------------------------------------    
   } 
//--------------------------------------------   ------------------------------------------------------------------------

//--------------------------------------------      -----------------------------------------------------------
  for(;;)
   {                                          
    if (button == 1)                        //     
     {
      switch (state)                        //       
       {
        case 1: state = 3; time_write(); TMR0IE_bit = 1; OUT = 1; break;// ! -   ר      ,    ,  
        case 2: state = 3; OUT = 1; break;  //   -   ר,  
        case 3: state = 2; OUT = 0; break;  //  ר -   ,  
        case 4:                             //  
         {
          state = 1;                        // !
          EEPROM_write(0x00, preset);       //   
          delay_ms(25);                     //  25 -    ,    .
          time_read();                      //    
         }
       }
      clear();                              //   ,  
     }
   
    if (button == 2)                        //     
     {
      switch (state)                        //       
       {
        case 1: state = 4; break;           //  ! -   
        case 2:                             // 
         {
          state = 1;                        //   
          time = time_set * 5;              //     
          TMR0IE_bit = 0;                   //    
          break;
         }
        case 3:                             //  ר
         {
          OUT = 0;                          //  
          TMR0IE_bit = 0;                   //    
          state = 1;                        //   !
          time = time_set * 5;              //     
          break;
         }
        case 4:                             //  
         {
          state = 1;                        //   !
          EEPROM_write(0x00, preset);       //   
          delay_ms(25);                     //  25.     ,    
          time_read();                      //    
         }
       }
      clear();                              //   ,  
     }   
   
    if (state == 1)                         //   !      
     {
      time = time + encoder * 5;            //       
      encoder = 0;                          //    
      if (time <= 0)                        //  ,     
       {
        beep();                             //  
        time = 5;                           //  
       }
      if (time >= 1000)                     //  ,     
       {
        beep();                             //  
        time = 995;                         //  
       }
     }
     
    if (state == 2)                         //     
     {
      PORTA = 0;                            //   
      delay_ms(LED_time * 10);              // 
     }  
     
    if (state == 3 && time <= 0)            //   ר   
     {
      OUT = 0;                              //  
      state = 1;                            //   !
      beep();
      beep();
      beep();
      while(timer_tick < tick_number-50)    //     
       {
        if(beep_on == 1) BUZZER = 1;        //    - 
        digit = 16;                         //  d
        place = 0;                          // 
        display();                          // 
        digit = 10;                         //  n
        place = 1;                          // 
        display();                          // 
        digit = 19;                         //  E
        place = 2;                          // 
        display();                          // 
       }
      TMR0IE_bit = 0;                       //    
      BUZZER = 0;                           //  
      time = time_set * 5;                  //   
     }
     
    if (state == 4)                         //        
     {
      preset = preset + encoder;            //    
      encoder = 0;                          //    
      if (preset < 1)                       //  ,     
       {
        beep();                             //  
        preset = 1;                         //  
       }
      if (preset > 9)                       //  ,     
       {
        beep();                             //  
        preset = 9;                         //  
       }
     }     
//--------------------------------------------    ------------------------------------------------------------------------
    if (state == 4) digit = 12;             //    -   P
     else digit = time/100;                 //   
    if (digit == 0) digit = 99;             //  0,    ,      
    place = 2;                              //  - 
    display();                              // 

    if (state == 4) digit = 13;             //    -   r
     else digit = time%100/10;              //   
    if (time < 100 && digit == 0)digit = 99;//  0   100,    ,           
    place = 1;                              //  - 
    display();                              // 

    if (state == 4) digit = preset;         //    -   
     else digit = time%10;                  //   
    place = 0;                              //  - 
    display();                              // 
//--------------------------------------------     -----------------------------------------------------------------
   }//----------------------------------------       ----------------------------------------------------
 }//==========================================   ============================================================================